#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <doslib.h>
#include "porter.h"

#define KEYFLAG  1	/* <key> Toǂ */
#define SMTPFLAG 2	/* SMTPT[o[ݒ荀ڂTo */
#define MAILFLAG 4	/* Mailݒ荀ڂTo */
#define NAMEFLAG 8	/* [U[  */
#define HOSTFLAG 16	/* zXg  */

static char *GetNewName(char *dirname);
static void send_errlog(struct _porter *q, char *spool);
static int sendpomp (struct _porter *q, char *str);
static FILE *open_smailrc(struct _porter *q);
static int getblkinf(struct _porter *q, FILE *fp);
static int open_errlog (struct _porter *q);


/* fBNgŎgĂȂt@C쐬 */
static char *GetNewName(char *dirname)
{
	int newfile = 0;
	struct FILBUF files_buf;
	static char OpenTestName[FILE_LEN];

	/* Vt@C𔭌܂ő */
	while (TRUE) {
		sprintf (OpenTestName, "%s%d", dirname, newfile);

		/* `FbN...t@CȂ΂nj */
		if (FILES(&files_buf, OpenTestName, 0x20) < 0)
			return OpenTestName;

		/* t@CΌJԂ */
		newfile++;
	}
}

/* G[O mailspool Ɉړ */
static void send_errlog(struct _porter *q, char *spool)
{
	int	len;
	char *r;
	char buf[STR_LEN];

	/* home ̓WJ */
	r = spool;
	if (spool[0] == '~') {
		strcpy (buf, q->home);
		r++;
		if (*r == '/' || *r == '\\')	r++;
	} else {
		buf[0] = '\0';
	}
	strcat (buf, r);

	/* Ō \ t */
	len = strlen (buf);
	if (len) {
		if (buf[len - 1] != '\\') {
			buf[len++] = '\\';
			buf[len] = '\0';
		}
	}

	/* ړ */
	rename (q->errlog, GetNewName (buf));
}

/* YfBNg̃t@CSđM */
static int sendpomp (struct _porter *q, char *str)
{
	int found;
	char filename[FILE_LEN];
	char buf[STR_LEN];
	struct FILBUF files_buf;

	if (!*str)	return (0);

	sprintf (filename, "%s%s\\*", q->qdir, str);
	found = FILES (&files_buf, filename, 0x20);
	if (found < 0) {
		VerbosePrintf ("%s ɂ̓[܂\n", str);
		return (0);
	}

	switch (LoginSession (q->SmtpHost)) {
	case LOGIN_OK:
		break;
	case LOGIN_ERROR:
		LogoffSession ();
	default:
		return (-1);
	}

	while (found >= 0) {
		sprintf (filename, "%s%s\\%s", q->qdir, str, files_buf.name);
		fputs (filename, stdout);
		fputs (" 𑗐MĂ܂\n", stdout);
		if (PostOne (q, filename) < 0) {
			FILE *fp = fopen (filename, "rt");
			if (fp) {
				fputs ("Content-Type: Message/Rfc822\n", q->errfp);
				fputs ("Content-Transfer-Encoding: 7bit\n\n", q->errfp);
				while (fgets (buf, sizeof(buf), fp)) {
					fputs (buf, q->errfp);
				}
				fclose (fp);
				fprintf (q->errfp, "--%s", q->boundary);
			}
			q->errct++;
		}
		remove (filename);
		found = NFILES (&files_buf);
	}
	LogoffSession ();
	return (0);
}

/* smail.rc TĊJ */
static FILE *open_smailrc (struct _porter *q)
{
	FILE *fp;
	char *ptr;
	char TempStr[FILE_LEN];

	/* ܂ SMAIL_CONFIG */
	ptr = getenv ("SMAIL_CONFIG");
	if (ptr) {
		fp = fopen (ptr, "rt");
		if (!fp) {
			fputs ("ϐSMAIL_CONFIĜt@C݂܂łB\n",
				stdout);
			return NULL;
		}
	} else {
		if (!q->home[0]) {
			fputs ("smail.rc ̈ʒuݒ肵ĂB\n", stdout);
			return NULL;
		}

		/*  HOME/smail.rc */
		sprintf (TempStr, "%ssmail.rc", q->home);
		fp = fopen (TempStr, "rt");
		if (!fp) {

			/* Ō HOME/.smailrc */
			sprintf (TempStr, "%s.smailrc", q->home);
			fp = fopen (TempStr, "rt");
			if (!fp) {
				fputs ("phatom2 : smail.rc ܂B\n", stdout);
				return NULL;
			}
		}
		ptr = TempStr;
	}

	VerbosePrintf ("%s ܂\n", ptr);
	return fp;
}

/* smail.rc eL[̏𓾂 */
static int getblkinf(struct _porter *q, FILE *fp)
{
	char *ptr;
	char flag = 0;
	char TempStr[SET_LEN];

	/* SMTPzXgƃ[AhXTo */
	while (fgets (TempStr, sizeof(TempStr), fp)) {
		/* sŃL[̏I[Ƃ݂Ȃ */
		if (TempStr[0] == '\n')	break;
		if (TempStr[0] == '#')	continue;

		if (ptr = GetKeyword(TempStr, "SMTP:")) {
			/* smtp ̌o */
			strcpy (q->SmtpHost, ptr);
			flag |= SMTPFLAG;

		} else if (ptr = GetKeyword(TempStr, "MAIL:")) {
			/* mail ̌o */
			strcpy(q->MailAdress, ptr);
			flag |= MAILFLAG;

		} else if (ptr = GetKeyword(TempStr, "HOST:")) {
			/* host ̌o */
			q->HostName[0] = '@';
			strcpy (q->HostName + 1, ptr);
			flag |= HOSTFLAG;
		}
	}

	/* G[\h */
	if (flag != (SMTPFLAG|MAILFLAG|HOSTFLAG)) {
		fprintf (stdout, "ݒt@C̃L[<%s>̐ݒ肪sĂ܂\n",
				q->Key);
		return FALSE;
	}
	return TRUE;
}

/* G[Ot@C̏ */
static int open_errlog (struct _porter *q)
{
	time_t nowtime;
	struct tm tm_time;

	q->errfp = fopen (q->errlog, "wt");
	if (!q->errfp) {
		fputs ("G[Oo͂ł܂\n", stdout);
		return FALSE;
	}

	time(&nowtime);
	tm_time = *localtime(&nowtime);
	sprintf (q->boundary, "--porter%4.4d%2.2d%2.2d%2.2d%2.2d%2.2d\n",
			tm_time.tm_year + 1900, tm_time.tm_mon + 1, tm_time.tm_mday,
			tm_time.tm_hour, tm_time.tm_min, tm_time.tm_sec);

	fputs ("Subject: error mails in smtp transfer\n", q->errfp);
	fputs ("From: porter\n", q->errfp);
	fputs ("To: Administrator\n", q->errfp);
	fputs ("MIME-Version: 1.0\n", q->errfp);
	fputs ("Content-Type: Multipart/Mix; boundary=", q->errfp);
	fputs (q->boundary, q->errfp);
	fputs ("Content-Transfer-Encoding: 7bit\n\n", q->errfp);
	fputs (q->boundary, q->errfp);
	return TRUE;
}


/* smail.rc QƂđM */
void SendMail(struct _porter *q)
{
	FILE *fp;
	char *ptr = NULL;
	char TempStr[SET_LEN];

	sprintf (q->errlog, "%serror.log", q->qdir);
	if (!open_errlog (q))	return;

	fp = open_smailrc (q);
	if (!fp)	return;

	/* smail.rc L[To */
	while (fgets (TempStr, sizeof(TempStr), fp)) {
		if (TempStr[0] == '#' || TempStr[0] == '\n')	continue;

		if ((ptr = GetKeyword (TempStr, "!"))
				&& strcmpi (ptr, "default-pop3")) {
			strcpy (q->Key, ptr);
			VerbosePrintf ("L[<%s>܂\n", q->Key);
			if (getblkinf (q, fp))	sendpomp (q, ptr);
		} else if (ptr = GetKeyword(TempStr, "MAILSPOOL:")) {
			break;
		}
		ptr = NULL;
	}
	fclose(fp);

	/* MG[[ŕ */
	fclose (q->errfp);
	if (q->errct) {
		if (ptr) {
			send_errlog (q, ptr);
		} else {
			fputs ("mailspool ݒ肪܂\n", stdout);
		}
	} else {
		remove (q->errlog);
	}
}

/* ϐ擾 */
int getenvdir (char *dest, char *envname)
{
	char *r, *w = dest;

	if (r = getenv (envname)) {
		while (*r) {
			/* /  \ ɕϊ */
			if (*r == '/') {
				*w++ = '\\';
				r++;
			} else {
				*w++ = *r++;
			}
		}

		/* Ō \ t */
		if (w != dest && w[-1] != '\\')	*w++ = '\\';
	}
	*w = '\0';

	return (int)r;
}
